#2574 closed defect (fixed)

m68k/av5282: linker script update (add KEEP() sections)

Reported by: Joel Sherrill Owned by: Joel Sherrill
Priority: normal Milestone: Indefinite
Component: bsps Version: 5
Severity: normal Keywords: function sections, KEEP
Cc: Blocked By:
Blocking:

Description

This BSP's linker script does not include KEEP() directives and thus cannot have per-function and per-data element section support enabled.

The preferred solution is to convert the BSP to use a shared base linker script. The acceptable solution is to add the proper KEEP directives to the existing linker script(s).

Shared linker scripts for the arm, m68k, and sparc have the proper KEEP sections and can serve as examples.

Change History (6)

comment:1 Changed on Feb 15, 2017 at 1:49:47 PM by Sebastian Huber

Owner: set to Joel Sherrill
Status: newassigned

comment:2 Changed on May 11, 2017 at 7:31:02 AM by Sebastian Huber

Milestone: 4.124.12.0

comment:3 Changed on Aug 24, 2017 at 5:59:58 AM by Sebastian Huber

Milestone: 4.12.0Indefinite

comment:4 Changed on Sep 14, 2018 at 6:21:26 PM by Joel Sherrill

Keywords: function-sections added

comment:5 Changed on Sep 14, 2018 at 7:00:33 PM by Joel Sherrill

Keywords: function sections KEEP added; function-sections removed

comment:6 Changed on Nov 27, 2018 at 3:26:27 PM by Shashvat Jain <shashvatjain2002@…>

Resolution: fixed
Status: assignedclosed

In 89bff5a/rtems:

m68k/av5282: Add per-section compilation and linking support (GCI 2018)

The size of the sample executables without this option were:

text data bss dec hex filename

83168 1152 11904 96224 177e0 base_sp.exe

199184 2096 14848 216128 34c40 capture.exe
252496 2912 12912 268320 41820 cdtest.exe
861872 21888 19648 903408 dc8f0 cxx_iostream.exe
564816 4640 24304 593760 90f60 fileio.exe
117168 1504 12048 130720 1fea0 hello.exe
261216 6016 18688 285920 45ce0 loopback.exe

67200 1008 8768 76976 12cb0 minimum.exe

106336 1632 12016 119984 1d4b0 nsecs.exe
191856 1904 12624 206384 32630 paranoia.exe
430224 12048 41472 483744 761a0 pppd.exe

85920 1168 11936 99024 182d0 ticker.exe
85984 1120 15808 102912 19200 unlimited.exe

The size of the sample executables with this option were:

text data bss dec hex filename

78512 1136 11824 91472 16550 base_sp.exe

185584 2096 14800 202480 316f0 capture.exe
184192 2144 12864 199200 30a20 cdtest.exe
184384 2224 13072 199680 30c00 cxx_iostream.exe
552288 4624 23984 580896 8dd20 fileio.exe
108224 1504 12016 121744 1db90 hello.exe
245168 6016 18608 269792 41de0 loopback.exe

62416 1008 8688 72112 119b0 minimum.exe

100256 1616 11936 113808 1bc90 nsecs.exe
183216 1904 12592 197712 30450 paranoia.exe
417648 12048 41392 471088 73030 pppd.exe

81024 1168 11856 94048 16f60 ticker.exe
84176 1120 15776 101072 18ad0 unlimited.exe

Closes #2574

Note: See TracTickets for help on using tickets.